<template>
	<f7-page name="financialreportform" @page:beforein="onPageBeforeIn" @page:beforeout="onPageBeforeOut">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large>
			<f7-nav-left back-link></f7-nav-left>
            <f7-nav-title class="show-small-title">Permintaan Pinjam / Sewa</f7-nav-title>
            <f7-nav-title-large>{{ formType }} Permintaan</f7-nav-title-large>
		</f7-navbar>
        <f7-block style="text-align: justify;padding:20px;border-radius:7px;" class="gradient-cyan">
            <h3 class="no-margin">Penting!</h3>
            <p>Sebagai warga perumahan anda dapat mengajukan permintaan  pinjam / sewa barang inventaris untuk anda pribadi atau untuk orang lain atas nama anda.</p>
        </f7-block>        
        <f7-list no-hairlines class="no-margin-bottom">
            <f7-list-input
                ref="name"
                label="Penanggung Jawab"
                placeholder="Nama lengkap"
                maxlength="255"
                :value="inventoryForm.name"
                @input="inventoryForm.name = $event.target.value">
            </f7-list-input>            
            <f7-list-input
                ref="address"
                type="textarea"
                label="Alamat"
                placeholder="Ketik alamat lengkap"
                resizable					
                :value="inventoryForm.address"
                @input="inventoryForm.address = $event.target.value">
            </f7-list-input>
            <f7-list-item
                link
                title="Kode Pos"
                :after="inventoryForm.postal"
                popup-open=".region-popup"
            >
            </f7-list-item>
            <f7-popup @popup:opened="regionPopupOpen" @popup:closed="regionPopupClose($event)" class="region-popup">
                <f7-view>
                    <f7-page>
                        <f7-navbar>
                            <f7-nav-left>
                                <f7-link icon-f7="arrow_left" popup-close=".region-popup"></f7-link>
                            </f7-nav-left>
                            <f7-nav-title>Kode Pos</f7-nav-title>
                            <f7-subnavbar :inner="false">
                                <f7-searchbar
                                    custom-search 
                                    @searchbar:search="handleRegionSearch"
                                    :disable-button="false"
                                    placeholder="Ketik Kode Pos"
                                    :clear-button="true"
                                ></f7-searchbar>
                            </f7-subnavbar>
                        </f7-navbar>
                
                        <f7-block v-if="regions.length > 0">
                            <f7-list media-list no-hairlines>
                                <f7-list-item
                                    link
                                    v-for="(region, index) in regions"
                                    :key="index"
                                    :title="region.name + ' ('+region.postal+')'"
                                    :subtitle="region.administrative.join(', ')"
                                    @click="addRegion(region)"
                                >
                                    <f7-icon slot="media" material="location_on" size="32" class="color-smoothgray"></f7-icon>
                                </f7-list-item>                                    
                            </f7-list>
                        </f7-block>
                        <f7-block v-else style="height: calc(100% - 100px)">
                            <span class="display-flex align-items-center justify-content-center" style="height:calc(100% - 100px);">
                                <span class="text-align-center">
                                    <span class="display-block text-align-center">
                                        <f7-icon material="location_on" style="font-size:100px;" class="color-smoothgray"></f7-icon>
                                        <span class="display-block">Area tidak ditemukan</span>
                                    </span>
                                </span>
                            </span>
                        </f7-block>
                    </f7-page>
                </f7-view>
            </f7-popup>
        </f7-list>
        <f7-list inline-labels no-hairlines class="no-margin border-separator-top">
            <li class="item-content item-input">
                <div class="item-inner">
                    <div class="item-title item-label">Jenis Permintaan</div>
                    <div class="item-input-wrap">
                        <p class="no-margin text-align-right">
                            <f7-radio 
                                name="status" 
                                value="onloan" 
                                :checked="inventoryForm.status === 'onloan'"
                                @change="inventoryForm.status = $event.target.value"></f7-radio> Pinjam
                            <f7-radio 
                                name="status" 
                                value="rentedout"
                                :checked="inventoryForm.status === 'rentedout'"
                                @change="inventoryForm.status = $event.target.value"></f7-radio> Sewa
                        </p>
                    </div>
                </div>
            </li>
            <f7-list-item title="Barang Inventaris" smart-select :smart-select-params="{'closeOnSelect': true}">
                <select 
                    ref="inventory" 
                    name="inventory" 
                    :value="inventoryForm.inventory"
                    @change="inventoryForm.inventory = $event.target.value">
                    <option
                        v-for="item in inventories" 
                        :value="item.id"
                        v-bind:key="item.id">{{ convertAmpersand(item.title) }}</option>
                </select>
            </f7-list-item>  
            <f7-list-input
                class="align-right"
                ref="phone"
                type="number"
                label="No. Handphone"
                placeholder="08xxxxxxxxxx"
                maxlength="255"
                :value="inventoryForm.phone"
                @input="inventoryForm.phone = $event.target.value">
            </f7-list-input>
            <li class="align-right">
                <div class="item-content item-input">
                    <div class="item-inner">
                    <div class="item-title item-label">Durasi</div>
                    <div class="item-input-wrap">
                        <input type="text" placeholder="Pilih Tanggal" readonly="readonly" id="duration"/>
                    </div>
                    </div>
                </div>
            </li>
            <f7-list-input
                class="align-right"
                ref="quantity"
                type="number"
                label="Kuantitas"
                placeholder="0"
                :value="inventoryForm.quantity"
                @input="inventoryForm.quantity = parseInt($event.target.value)">
            </f7-list-input>
        </f7-list>
        <f7-list no-hairlines class="no-margin border-separator-top">
            <f7-list-input
                ref="description"
                type="textarea"
                label="Catatan"
                placeholder="Ketik catatan anda"
                resizable					
                :value="inventoryForm.description"
                @input="inventoryForm.description = $event.target.value">
            </f7-list-input>           
        </f7-list>        
        <br>
        <f7-button @click="doSubmit" fill-ios round-ios color="white" icon-f7="arrow_right" class="gradient-button-blue text-align-left" large>Kirim Permintaan</f7-button>
    </f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { dateFormat, capitalize, parseError, convertAmpersand } from '../js/utils';
import { setTimeout } from 'timers';
export default {
    name: 'InventoryForm',
    data(){
        return{
            formType: 'Buat',
            inventoryForm: {
                id: null,
                inventory: null,
                name: '',
                phone: '',
                address: '',
                region: null,
                postal: null,
                duration: [new Date(), new Date()],
                quantity: 1,
                cost: 0,
                description: '',
                status: 'waiting',
                author: null,
                residential: null,
                status: 'onloan'
            }
        }
    },
    computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('region', ['regions']),
		...mapGetters('inventory', [
			'inventories'
        ]),
        ...mapGetters('movement', [
			'movement'
		])
    },
    methods: {
        dateFormat,
        convertAmpersand,
        yesterday(){
            let today = new Date();
            let yesterday = new Date();
            return yesterday.setDate(today.getDate()-1);
        },
        parseRegion(postal, path){
            path = path.split('/');
            path.reverse();
            return postal + ' - ' + capitalize(path[0].replace('-', ' '));
        },
        getInventories(){
			const self = this;
			const app = self.$f7;

			self.$store.dispatch('inventory/getInventories', {
                module: 'inventory',
                only: 'id,number,title,quantity,received_date,residential.name,residential.administrative_region,residential.address,created,updated,medias.id,medias.mimetype,medias.original_filename,medias.filename,medias.url,author.id,author.profile.fullname,author.profile.initial,author.profile.media,category.id,category.name'
			});
        },
        onPageBeforeIn(){
			const self = this;
			const app = self.$f7;
			const $$ = self.$$;
			const $el = $$(self.$el);

			if(self.$f7route.params && self.$f7route.params.id){
				self.formType = 'Ubah';
				self.inventoryForm.id = self.$f7route.params.id;
			
				app.preloader.show('green');

				self.$store.dispatch('inventory/viewInventory', {
                    id: self.inventoryForm.id,
                    only: 'id,number,title,quantity,received_date,residential.name,residential.administrative_region,residential.address,created,updated,medias.id,medias.mimetype,medias.original_filename,medias.filename,medias.url,author.id,author.profile.fullname,author.profile.initial,author.profile.media,category.id,category.name'
				}).then((response) => {
					
					self.inventoryForm.inventory = self.movement.inventory.id;
					self.inventoryForm.name = self.movement.name;
                    self.inventoryForm.address = self.movement.address;
                    self.inventoryForm.region = self.movement.region.id;
                    self.inventoryForm.postal = self.movement.region.postal;
                    self.inventoryForm.deration = self.movement.duration;
                    self.inventoryForm.quantity = self.movement.quantity;
                    self.inventoryForm.cost = self.movement.cost;
                    self.inventoryForm.description = self.movement.description;
                    self.inventoryForm.status = self.movement.status;
					
                    $el.find('select.inventory').find('option[value="'+self.movement.inventory.id+'"]').prop('selected', true).trigger('change');

					app.preloader.hide();
				});
            }     
            
            self.inventoryForm.author = self.user.id;
            self.inventoryForm.residential = self.user.residential.id;
            
		},
		onPageBeforeOut(page){
			const self = this;

			if(page.detail.name == 'inventoryform'){
				self.inventoryForm = {
					id: null,
                    inventory: null,
                    name: '',
                    phone: '',
                    address: '',
                    region: null,
                    postal: null,
                    duration: [new Date(), new Date()],
                    quantity: 1,
                    cost: 0,
                    description: '',
                    status: 'waiting',
                    author: null,
                    residential: null
				}
			}
        },
        doSubmit(){
            const self = this;
            const app = self.$f7;

            if(self.inventoryForm.inventory == null){
                app.dialog.alert('Silahkan pilih barang inventaris.', 'RingSatu');
                return false;
            }else if(self.inventoryForm.name.trim().length == 0){
                app.dialog.alert('Nama penanggung jawab wajib diisi.', 'RingSatu');
                return false;
            }else if(/^([a-zA-Z0-9\s]{1,255})$/.test(self.inventoryForm.name) == false){
				app.dialog.alert('Nama penanggung jawab hanya boleh diisi dengan dengan huruf, angka dan spasi.', 'RingSatu');
				return false;
            }else if(/\(?(?:\+628|628|08)(?:\d{2,3})?\)?[ .-]?\d{2,4}[ .-]?\d{2,4}[ .-]?\d{2,4}/.test(self.inventoryForm.phone) == false){
                app.dialog.alert('No. Handphone harus diawali dengan 08, +628 atau 628.', 'RingSatu');
				return false;
            }else if(self.inventoryForm.address.trim().length == 0){
				app.dialog.alert('Alamat wajib diisi.', 'RingSatu');
                return false;
            }else if(self.inventoryForm.address.trim().length > 255){
				app.dialog.alert('Alamat tidak boleh lebih 255 karakter.', 'RingSatu');
                return false;
            }else if(self.inventoryForm.region == null){
				app.dialog.alert('Kode pos wajib diisi.', 'RingSatu');
                return false;
            }else if(self.inventoryForm.quantity == '' || self.inventoryForm.quantity == 0){
				app.dialog.alert('Kuantitas wajib diisi.', 'RingSatu');
                return false;
            }else if(self.inventoryForm.description.trim().length > 255 ){
				app.dialog.alert('Catatan tidak boleh lebih 255 karakter.', 'RingSatu');
                return false;
            }

            let action = '';
			let params = {};

			if(self.formType == 'Ubah'){
				params.id = self.$f7route.params.id;
				action = 'movement/editMovement';
			}else{
				action = 'movement/createMovement';
			}

			params.status = self.inventoryForm.status;
			params.inventory = parseInt(self.inventoryForm.inventory);
			params.name = self.inventoryForm.name;
			params.phone = self.inventoryForm.phone;
            params.address = self.inventoryForm.address;
            params.region = self.inventoryForm.region;
            params.duration = self.inventoryForm.duration;
            params.quantity = self.inventoryForm.quantity;
            params.cost = self.inventoryForm.cost;
            params.description = self.inventoryForm.description;
			params.author = self.user.id;
            params.residential = self.inventoryForm.residential;
            params.only = 'id,number,title,quantity,received_date,residential.name,residential.administrative_region,residential.address,created,updated,medias.id,medias.mimetype,medias.original_filename,medias.filename,medias.url,author.id,author.profile.fullname,author.profile.initial,author.profile.media,category.id,category.name'
            
            app.preloader.show('green');

            self.$store.dispatch(action, params).then((response) => {
                app.preloader.hide();
                if('errors' in response){
					let error = parseError(response.errors);
					app.dialog.alert(error.messages, 'RingSatu');
					return false;
				}else{
					self.$f7router.back({
						ignoreCache: true
					});
				}
            });
        },
        addRegion(region){
            const self = this;
            const app = self.$f7;

            self.inventoryForm.region = region.id;
            self.inventoryForm.postal = region.postal;

            var regionPopup = app.popup.get('.region-popup');
            if(regionPopup){
                regionPopup.close();
            }
        },
        regionPopupOpen(){
            const self = this;
            const app = self.$f7;
        },
        regionPopupClose(e){
            const self = this;
            const app = self.$f7;

            self.$store.dispatch('region/resetRegions');
        },
        handleRegionSearch(sb, query, prevQuery){
            const self = this;
            const app = self.$f7;

            if(query.length >= 3){
                app.preloader.show('yellow');
                self.$store.dispatch('region/getRegions', {
                    q: query,
                    only: 'id,name,slug,path,latitude,longitude,administrative,postal'
                }).then((response)=>{
                    app.preloader.hide();
                    if('errors' in response){
                        self.$store.dispatch('region/resetRegions');
                    }
                });
            }
        },
    },
    mounted(){
        const self = this;
        const app = self.$f7;
        const $$ = self.$$;
        const $el = $$(self.$el);

        let duration = app.calendar.create({ 
            inputEl: '#duration',
            closeOnSelect: true,
            dateFormat: 'dd/mm/yyyy', 
            rangePicker: true, 
            minDate: self.yesterday(),
            value: self.inventoryForm.duration,
            monthNames: ['Januari', 'Februari', 'Maret', 'April', 'Mei', 'Juni', 'Juli', 'Agustus', 'September', 'Oktober', 'November', 'Desember'],
            monthNamesShort: ['Jan', 'Feb', 'Mar', 'Apr', 'Mei', 'Jun', 'Jul', 'Agu', 'Sep', 'Okt', 'Nov', 'Des'],
            dayNames: ['Minggu', 'Senin', 'Selasa', 'Rabu', 'Kamis', 'Jumat', 'Sabtu'],
            dayNamesShort: ['Min', 'Sen', 'Sel', 'Rab', 'Kam', 'Jum', 'Sab'],
            on: {
                change: function(p,values,displayValues){
                    var start= new Date(values[0]);
                    var end = new Date(values[1]); 
                    self.inventoryForm.duration = [start, end];
                }
            }
        });
    }
}
</script>
